// Next.js API route support: https://nextjs.org/docs/api-routes/introduction
import axios from 'axios';
import { Cookies } from 'react-cookie';
import cookie from 'cookie';
import moment from 'moment';
import jwt from 'jsonwebtoken';
import { cors } from '../../../lib/cors';
import { inspect } from 'util';

export default async function handler(req, res) 
{
	console.log("API", "questionnaire", "get");
	await cors(req, res);

	if(req.headers.cookie !== undefined)
	{
		const cookies = cookie.parse(req.headers?.cookie ? req.headers?.cookie : "");

		if(cookies.jwt !== undefined && cookies.jwt !== null)
		{
			var client_jwt_decoded = jwt.verify(cookies.jwt, process.env.JWT_SECRET_CLIENT);
			var crm_jwt = jwt.sign({ acc_number: client_jwt_decoded.acc_number }, process.env.JWT_SECRET_CRM, { noTimestamp: true });

			const path = `${ process.env.CRM_API_HOST }/lk/Questionnaire/InfoQuestionnaire/`;

			try
			{
				const { id } = req.query;
				await axios.get(path, {
					params: { name: id }, 
					headers: {
						"Authorization": `Bearer ${ crm_jwt }`, 
					} 
				})
				.then((crm_response) => 
				{
					console.log("crm_response for", path);
					console.log(inspect(crm_response.data, true, null, true));

					res.status(200).json(crm_response.data);
				})
				.catch((error) => 
				{
					console.error(error);
					console.error("-".repeat(30), "error.response.data:");
					console.error(error.response.data);

					res.status(500).json(error.response.data);
				});
			}
			catch(e)
			{
				console.error(e);
				res.status(500).send(e);
			}
		}
		else
		{
			res.status(403);
		}
	}
}